Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports Telerik.Web.UI
Imports Telerik.OpenAccess.MetaData
Imports Telerik.OpenAccess.MetaData.Relational
Imports Telerik.OpenAccess

Partial Public Class OpenAccessMetadata
	Inherits System.Web.UI.UserControl
	Private container As MetaDataContainer

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
		container = Database.Get("DatabaseConnection1").MetaData
		If (Not Page.IsPostBack) Then
			Dim root As New RadTreeNode("Northwind")
			Dim tables As New RadTreeNode("Tables and Views")
			Dim storedProcs As New RadTreeNode("Stored Procedures")
			PopulateTables(tables)
			PopulateStoredProcs(storedProcs)
			root.Nodes.Add(tables)
			root.Nodes.Add(storedProcs)
			RadTreeView1.Nodes.Add(root)
		End If
	End Sub
	Protected Sub RadTreeView1_NodeClick(ByVal sender As Object, ByVal e As Telerik.Web.UI.RadTreeNodeEventArgs)
		If e.Node.ParentNode IsNot Nothing Then
			If e.Node.ParentNode.Text = "Tables and Views" Then
				PopulatePropertyGridWithTableInfo(e.Node.Text, container)
			End If
		End If
	End Sub

	Private Sub PopulateStoredProcs(ByVal storedProcs As RadTreeNode)
		If storedProcs IsNot Nothing Then
			For Each node As RadTreeNode In GetStoredProcedures(container)
				storedProcs.Nodes.Add(node)
			Next node
		End If
	End Sub

	Private Sub PopulateTables(ByVal tables As RadTreeNode)
		If tables IsNot Nothing Then
			For Each node As RadTreeNode In GetTables(container)
				tables.Nodes.Add(node)
			Next node
		End If
	End Sub

	Private Function GetStoredProcedures(ByVal container As MetaDataContainer) As IEnumerable(Of RadTreeNode)
        Dim tableNodes As IEnumerable(Of RadTreeNode) = container.StoredProcedures.Select(Function(t) New RadTreeNode(t.Name))
		Return tableNodes
	End Function

	Private Function GetTables(ByVal container As MetaDataContainer) As IEnumerable(Of RadTreeNode)
        Dim tableNodes As IEnumerable(Of RadTreeNode) = container.Tables.Select(Function(t) New RadTreeNode(t.Name))
		Return tableNodes
	End Function

	Private Sub PopulatePropertyGridWithTableInfo(ByVal tableName As String, ByVal container As MetaDataContainer)
		Dim metaType As IEnumerable(Of MetaType) = container.PersistentTypes.Where(Function(p) p.Table.Name = tableName)
		RadGrid1.DataSource = metaType
		RadGrid1.DataBind()
	End Sub

	Private Sub PopulatePropertyGridWithStoredProcInfo(ByVal procedureName As String, ByVal container As MetaDataContainer)
        Dim procedure As IEnumerable(Of MetaStoredProcedure) = container.StoredProcedures.Where(Function(p) p.Name = procedureName)
	End Sub

	Protected Sub RadGrid1_DetailTableDataBind(ByVal source As Object, ByVal e As Telerik.Web.UI.GridDetailTableDataBindEventArgs)
		Dim dataItem As GridDataItem = CType(e.DetailTableView.ParentItem, GridDataItem)

		Dim metaTypeName As String = dataItem.GetDataKeyValue("Name").ToString()

        e.DetailTableView.DataSource = container.PersistentTypes.Where(Function(mt) mt.Name = metaTypeName).SelectMany(Function(mt) mt.Members)
	End Sub
End Class
